/*
 * LCD4x40_G2452_I2C
 * main
 *
 *  Created on: 7/dic/2013
 *
 *
 */






#include <msp430.h> 
#include "LCD4x40_430.h"

// Global Variable declarations
char flag;				//per uscire dal loop in I2C
char i,x;
const char slv_addr = 0X70;   // indirizzo di chiamata dello slave
const char disp[40]; 			// Una riga di Buffer per caratteri da inviare a LCD
char *s;
char LCD_data;
int I2C_State = 0;
// le due variabili che seguono sono solo di prova
unsigned int da_canc = 65432;					   // per prova da cancellare
const char STR1[] = "123456 prova LCD";




/*
 * main.c
 */
int main(void) {

    WDTCTL = WDTPW | WDTHOLD;	           // Stop watchdog timer
	  if (CALBC1_12MHZ==0xFF)			   // If calibration constants erased
	  {
	    while(1);                          // do not load, trap CPU!!
	  }
	  DCOCTL = 0;                          // Select lowest DCOx and MODx settings
	  BCSCTL1 = CALBC1_12MHZ;               // Set DCO
	  DCOCTL = CALDCO_12MHZ;

	  P1OUT = 0xC0;                        // P1.6 & P1.7 Pullups, altre a  0
	  P1REN |= 0xC0;                       // P1.6 & P1.7 Pullups
	  P1DIR = 0xFF;                        // Pin non usati settati e in uscita
	  P2OUT = 0;
	  P2DIR = 0xFF;

	  USICTL0 = USIPE6+USIPE7+USIMST+USISWRST; // Port & USI in modo setup
	  USICTL1 = USII2C+USIIE;                  // abilita I2C & USI interrupt
	  USICKCTL = USIDIV_4+USISSEL_2+USICKPL;   //USI clocks: SCL = SMCLK/16
	  USICNT |= USIIFGCC;                      // Disabilita automatic clear control
	  USICTL0 &= ~USISWRST;                    // abilita USI
	  USICTL1 &= ~USIIFG;                      // Clear pending flag
	  _EINT();								   // Abilita interrupt

  reset_dys();
  // da qui alla fine del main  solo di prova
  cursor_blink(3);

  comand(3,1,1);
  dys_byte(0x35,1);

  comand(1,1,1);				// pos 1,riga 1,clock 1
  dys_string(STR1,1);

  comand(1,1,2);				//pos 10,riga 3,clock 2
  s = "prova dei CARATTERI se SONO 40 CARATTERI";
  dys_string(s,2);

  comand(5,2,1);
  dys_num(da_canc,1);			//pos 5,riga 2,clock 1

  comand(10,2,2);				//pos 10,riga 3,clock 2
   s = "1234567890          1234567890";
   dys_string(s,2);


  return 0;
}


/******************************************************
// USI interrupt service routine
******************************************************/
#pragma vector = USI_VECTOR
__interrupt void USI_TXRX (void)
{
  switch(I2C_State)
    {
      case 0: // Genera lo  Start e invia l'indirizzo
              P1OUT |= 0x01;          // LED on: sequence start
              USISRL = 0x00;           	// Genera LO  Start .....
              USICTL0 |= USIGE+USIOE;
              USICTL0 &= ~USIGE;
              USISRL = slv_addr;       	// ... e trasmette l'indirizzo dello slave
              USICNT = (USICNT & 0xE0) + 0x08; // Bit counter = 8, TX Address
              I2C_State = 2;           	// allo stato successivo: receive address (N)Ack
              break;

      case 2: // Receve Address Ack/Nack bit
              USICTL0 &= ~USIOE;       // SDA = input
              USICNT |= 0x01;          // Bit counter = 1, receve (N)Ack bit
              I2C_State = 4;           // allo stato successivo: check (N)Ack
              break;

      case 4: // Processa  Address Ack/Nack & trasmette  MST_data
              USICTL0 |= USIOE;        // SDA = output
              if (USISRL & 0x01)       // Se riceve un  Nack ...
              { // Trasmette uno  stop...
                USISRL = 0x00;
                USICNT |=  0x01;       // Bit counter = 1, SCL high, SDA low
                I2C_State = 10;        // Va allo stato successivo: generate Stop
                P1OUT |= 0x01;         // Accende il LED: errore
              }
              else
              { // Se ricevuto un Ack, TX data allo slave...
                USISRL = LCD_data;     // carica il data byte
                USICNT |=  0x08;       // Bit counter = 8, inizia TX
                I2C_State = 6;         // va allo stato successivo: receive data (N)Ack
                P1OUT &= ~0x01;      // spegne il LED
              }
              break;

      case 6: // Receve il bit Ack/Nack
              USICTL0 &= ~USIOE;       	// SDA = input
              USICNT |= 0x01;          	// Bit counter = 1, receve (N)Ack bit
              I2C_State = 8;           	// va allo stato successivo: verisica se  (N)Ack
              break;

      case 8: // Processa MST_data in funzione di  Ack/Nack & invio lo Stop
              USICTL0 |= USIOE;
              if (USISRL & 0x01)       		// se ha ricevuto un Nack ...
                P1OUT |= 0x01;         		// accende il LED: errore
              else                     		// se  invece un  Ack
              {
                LCD_data++;            		// Incrementa il Master data
                P1OUT &= ~0x01;        	// spegne il LED
              }
              // Send stop...
              USISRL = 0x00;
              USICNT |=  0x01;         		// Bit counter = 1, SCL high, SDA low
              I2C_State = 10;          		// va allo stato successivo: genera uno Stop
              break;

      case 10:// Genera la condizione di Stop
              USISRL = 0x0FF;          		// USISRL = 1 to release SDA
              USICTL0 |= USIGE;        		// Abilitato il Transparent latch
              USICTL0 &= ~(USIGE+USIOE);	//  Disabilita Latch/SDA output
              I2C_State = 0;           		// Resetta lo stato per una nuova trasmissione
              LPM0_EXIT;               		// stato attivo per il nuovo transfer
              flag=1;
              break;
    }

  USICTL1 &= ~USIIFG;                  // Clear il flag attivo
}


